Bug 1119711 - 2nd and 3rd level bulleted lists do not get a proper bullet symbol
Summary: 2nd and 3rd level bulleted lists do not get a proper bullet symbol
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: pandoc
Version: 26
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jens Petersen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-07-15 10:37 UTC by Brian (bex) Exelbierd
Modified: 2018-05-29 11:49 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-05-29 11:49:48 UTC


Attachments (Terms of Use)
Picture of the broken bullets in Libre Office Writer (3.33 KB, image/png)
2014-07-15 10:37 UTC, Brian (bex) Exelbierd
no flags Details

Description Brian (bex) Exelbierd 2014-07-15 10:37:43 UTC
Created attachment 918117 [details]
Picture of the broken bullets in Libre Office Writer

Description of problem:

When converting to ODT from Markdown and HTML, second and third level bullets in a bulleted list are the "missing symbol" symbol.

Version-Release number of selected component (if applicable):

On Fedora 20:
  pandoc 1.12.3.3
  Compiled with texmath 0.6.6.1, highlighting-kate 0.5.6.


How reproducible:

Always

Steps to Reproduce:
1. Create this markdown document

foo.md
--
* Level 1 OK
    * Level 2 broken
        * Level 3 broken
            * Level 4 OK
--

2. Execute:

pandoc -f markdown -t odt -o foo.odt foo.md

3. Open foo.odt in Libre Office Writer

Actual results:

Messed up bullets (see image)

Expected results:

Proper Bullets

Additional info:

This does not seem to be a problem with reference.odt.  The style settings there all appear OK.  My best guess is that pandoc is forcing either a font or bullet symbol that isn't shipped on Fedora and is overriding the default styling in reference.odt.

Comment 1 Jens Petersen 2014-07-16 01:49:50 UTC
Thanks for the report.

I suggest also reporting this to upstream: either to the google group
or in the github issue tracker, and then let's see what upstream says.

Also it would be interesting to know what symbol/glyph is being used...
You could try dragging/copy'n'pasting the char to gucharmap for example
to find out.

Comment 2 Brian (bex) Exelbierd 2014-07-16 11:03:03 UTC
A bit more clarity was posted in https://github.com/jgm/pandoc/issues/1400

Github didn't notify me of the update and I missed it before today.  It appears that there is a forced font.

I am going to close this and try to engage upstream.

Comment 3 Jens Petersen 2014-07-18 05:53:10 UTC
The missing character is U+2023 TRIANGULAR BULLET.

I agree it seems to be a font issue.

Comment 4 Jens Petersen 2014-07-18 08:02:10 UTC
But you're right, the liststyles seems to be generated by pandoc:

./Text/Pandoc/Writers/OpenDocument.hs:193:      automaticStyles = inTagsIndented "office:automatic-styles" $ vcat $
./Text/Pandoc/Writers/OpenDocument.hs:196:              $ defField "automatic-styles" (render' automaticStyles)

Comment 5 Brian (bex) Exelbierd 2014-07-21 07:18:35 UTC
The github issue is running dry again.  It appears the code was developed by someone who doesn't really monitor the project as a whole.

I don't know enough about ODT, but are we guaranteed any styles in an ODT file?  In otherwords, could we switch the code to use a list format we are positive will always be there?  I found where the styles are getting injected, but there is no check to see if they are duplicates.

Comment 6 Jens Petersen 2014-07-22 01:23:57 UTC
IMO pandoc should generate ODT that uses the default ODT style by default.
How does one specify a template file with pandoc?
I would need to stare at the code for a while to get any idea
how this could be fixed though maybe it is better we move
the discussion to the upstream bug.

I would prefer if pandoc only injected automatic-styles if
overriding the ODT defaults.

I don't have time to look at this right now but I think I will re-open
to try to revisit this later.  It may be a few months though...
Of course if someone can come up with a patch first then that
is most welcome too.

Comment 7 Brian (bex) Exelbierd 2014-07-22 09:15:26 UTC
There is a flag --reference-odt=filename.odt to call the reference file.

I did a bit more digging in the code and I believe the following to be true:

the ODT.hs writer opens the reference.odt and puts it verbatim into the output.  It doesn't parse it or look to see if there are styles it can use.

It also doesn't appear that OpenDocument defines default styles or style names.  It appears this is all implementation dependent.  Therefore, the fact that I have a bullet list defined in my reference.odt isn't being considered.  It seems the way to fix this is to do one of the following (rough ideas):

1) Search the odt styles and figure out if there is a bullet list.  If so, pick one and use it.  If not create our own default, ideally with bullets we can reasonably guarantee to exist.

2) Do something like the reST (reStructuredText) converter does and specify what styles will be used.  Those can then be defined in the shipped reference.odt and supplied in a user provided reference.odt.  You can see their documentation here: http://docutils.sourceforge.net/docs/user/odt.html#list-styles  I don't know that it is necessary to go further with allowing those names to be overriden.

Today's standard of using some LO style names and then defining custom lists seems to be a weird hybrid.

Lastly, it appears that bulletListToOpenDocument in the OpenDocument.hs writer is creating a new list style for each level of indention. This seems to indicate that listhandling may need to be refactored.

I realize you aren't going to work on it immediately, but I wanted to add these thoughts in case they help later.

Comment 8 Fedora End Of Life 2015-05-29 12:22:30 UTC
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 9 Jens Petersen 2015-06-01 03:43:36 UTC
Still same with pandoc-1.13.2.

Comment 10 Jan Kurik 2015-07-15 14:39:19 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23

Comment 11 Fedora End Of Life 2016-11-24 11:11:18 UTC
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 12 Jens Petersen 2016-12-19 10:24:40 UTC
Upstream bug is still open, and still happens for pandoc-1.19.1.

Comment 13 Fedora End Of Life 2017-02-28 09:37:28 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 26 development cycle.
Changing version to '26'.

Comment 14 Fedora End Of Life 2018-05-03 08:06:47 UTC
This message is a reminder that Fedora 26 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 26. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '26'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 26 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 15 Fedora End Of Life 2018-05-29 11:49:48 UTC
Fedora 26 changed to end-of-life (EOL) status on 2018-05-29. Fedora 26
is no longer maintained, which means that it will not receive any
further security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.